
#include "HotHelp.h"
#include <Functions.h>
#include <StdIO.h>
#include <String.h>


struct IntuitionBase *  IntuitionBase;
struct HotHelpBase *    HotHelpBase;


VOID main (VOID)
   {
   if (IntuitionBase = OpenLibrary ("intuition.library", 33))
      {
      if (HotHelpBase = OpenLibrary ("hothelp.library", 3))
         {
         struct TagItem tags [10];
         LONG           error;

         /*
            Dieses Beispiel zeigt die Verwendung der HH_Data- und
            HH_Export-Strukturen.
         */
         tags [0].ti_Tag   = HHT_ShowAbsolutLast;
         tags [0].ti_Data  = (ULONG) TRUE;
         tags [1].ti_Tag   = HHT_PosAbsolutLast;
         tags [1].ti_Data  = (ULONG) TRUE;
         tags [2].ti_Tag   = TAG_DONE;

         /*
            Im folgenden werden jetzt direkt nacheinander zwei
            HotHelp-Fenster geffnet, um ein Problem zu verdeutlichen.
            Whlen Sie dazu im ersten Fenster einige Querverweise aus.
            Jetzt knnten Sie noch ber das Vortext-Gadget auf die vorher
            gelesenen Texte zugreifen. Tun Sie das nicht und schlieen das
            Fenster, zeigt das zweite Fenster zwar denselben Text an, das
            Vortext-Gadget kann jetzt jedoch nicht ausgewhlt werden, da
            HotHelp die Informationen ber die vorhergehenden Eintrge nicht
            automatisch beibehlt.
         */
         if ((error = HH_ShowHelpTagList (NULL, tags)) ||
             (error = HH_ShowHelpTagList (NULL, tags)))
            printf ("Fehler %ld ist aufgetreten!\n", error);
         else
            {
            /*
               Wir legen nun eine HH_Data-Struktur an, fllen sie mit 0,
               initialisieren die Versions-Nummer und bergeben diese
               Struktur an HotHelp, um ein weiteres Fenster zu ffnen.
               Whlen Sie nun auch hier einige Querverweise aus und schlieen
               das Fenster, knnen Sie im nchsten Fenster ber das Vortext-
               Gadget auf die im vorigen Fenster gesehenen Eintrge zurck-
               greifen - HotHelp benutzt die Struktur, um diese und hnliche
               Informationen festzuhalten und dem nchsten Fenster, das mit
               dieser Struktur geffnet wird, zur Verfgung zu stellen.
               Sie sollten daher grundstzlich eine solche Struktur benutzen,
               wenn Sie im Laufe Ihres Programms mehrere HotHelp-Fenster
               ffnen mchten.
            */
            struct HH_Data hh_data;

            memset (&hh_data, 0, sizeof (struct HH_Data));
            hh_data.version = HH_VERSION;

            tags [2].ti_Tag  = HHT_DataStruct;
            tags [2].ti_Data = (ULONG) &hh_data;
            tags [3].ti_Tag  = TAG_DONE;

            if ((error = HH_ShowHelpTagList (NULL, tags)) ||
                (error = HH_ShowHelpTagList (NULL, tags)))
               printf ("Fehler %ld ist aufgetreten!\n", error);
            else
               {
               /*
                  ber die Struktur kann dem Fenster auch eine bestimmte
                  Gre vorgegeben werden; dafr darf dann allerdings das
                  PosAbolutLast-Flag nicht gesetzt werden!
               */

               hh_data.x       = 20;
               hh_data.y       = 30;
               hh_data.width   = 550;
               hh_data.height  = 100;
               tags [1].ti_Tag = TAG_IGNORE;

               if (error = HH_ShowHelpTagList (NULL, tags))
                  printf ("Fehler %ld ist aufgetreten!\n", error);
               else
                  {
                  /*
                     Die HH_Export-Struktur dient dazu, Informationen ber
                     den Export von Texten zu erhalten. Insbesondere ist ein
                     Export ber das Spezial-Gadget nur mglich, wenn diese
                     Struktur angegeben wird.
                     Daher wird nun eine solche Struktur angelegt, mit 0
                     initialisiert, mit der Versionsnummer versehen und an
                     HotHelp bergeben. Gleichzeitig ndern wir die
                     Beschriftung des Spezial-Gadgets noch um, so da seine
                     Bedeutung klar wird.
                  */
                  struct HH_Export  hh_export;

                  memset (&hh_export, 0, sizeof (struct HH_Export));
                  hh_export.version = HH_VERSION;

                  tags [3].ti_Tag  = HHT_ExportStruct;
                  tags [3].ti_Data = (ULONG) &hh_export;
                  tags [4].ti_Tag  = HHT_SpecialText;
                  tags [4].ti_Data = (ULONG) "Zum _Programm";
                  tags [5].ti_Tag  = TAG_DONE;

                  if (error = HH_ShowHelpTagList (NULL, tags))
                     printf ("Fehler %ld ist aufgetreten!\n", error);
                  else
                     {
                     if (hh_export.cut_filled)
                        {
                        /*
                           Bitte beachten Sie, da eine Rckmeldung ber
                           die Struktur nur erfolgt, wenn das Fenster beim
                           Export geschlossen wurde. Dies kann in
                           HotHelpPref im Steuerungs-Modul festgelegt
                           werden.
                        */
                        printf ("Es wurde Text exportiert...");
                        switch (hh_export.cut_type)
                           {
                           case HH_CUT_CLIPBOARD:
                              printf ("ins Clipboard!\n");
                              break;
                           case  HH_CUT_RAMFILE:
                              printf ("in die Datei %s\n",
                                                      hh_export.cut_file);
                              break;
                           case HH_CUT_SPECIAL:
                              printf ("ber das Spezial-Gadget!\n");
                              /*
                                 In 'hh_export.cut_text_buffer' befinden
                                 sich nun 'hh_export.cut_numb_chars'
                                 exportierte Zeichen, die hier entsprechend
                                 bearbeitet werden knnen. Anschlieend
                                 mssen sie wie unten gezeigt wieder
                                 freigegeben werden. Der Vorteil dabei ist,
                                 da der Text dem Programm direkt im
                                 Speicher vorliegt und so einfach
                                 ausgewertet werden kann.
                              */
                              FreeRemember (&hh_export.cut_remember, TRUE);
                              break;
                           }
                        }
                     else
                        printf ("Es wurde kein Text exportiert!\n");
                     }
                  }
               }
            }

         CloseLibrary (HotHelpBase);
         }
      else
         printf ("Fehler bei HotHelpBase\n");
      CloseLibrary (IntuitionBase);
      }
   else
      printf ("Fehler bei IntuitionBase\n");
   }


